<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        </v-col>
        <v-col cols="7">
            <h1>Log Config</h1>
        </v-col>
    </v-row>
    <v-row>
      <v-col>
         <v-data-table
            :headers="headers"
            :items="logs"
            :search="search"
            :custom-filter="doSearch"
            :single-expand="singleExpand"
            :expanded.sync="expanded"
            item-key="id"
            show-expand
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length">
              <div v-if="item.logConfigDetails">
                <div v-for="logconfig in item.logConfigDetails" :key="logconfig.id">
                  <v-container>
                    <pre>
                    {{ logconfig.cmd }} </pre>
                    <pre>{{ logconfig.result }}</pre>
                  </v-container>
                </div>
              </div>
            </td>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import service from "../service/LogConfigService";

export default {
  name:'LogConfig',
  components: {
    DlgMsg,
    Loading,
  },
  data:function() {
    return {
      expanded: [],
      singleExpand: true,
      search: '',
      logs: [],
      logsDetail: [],
      title: null,
      headers:[
        {text: '', value: 'data-table-expand' },
        {text: "No.", align: "center", value: "number", sortable: true},
        {text: "TARGET", align: "center", value: "target", sortable: true},
        {text: "ACTION", align: "center", value: "action", sortable: true},
        {text: "STATUS", align: "center", value: "status", sortable: true},
        {text: "USERNAME", align: "center", value: "username", sortable: true},
        {text: "IP CLIENT", align: "center", value: "ip_client", sortable: true},
        {text: "START TIME", align: "center", value: "start_time", sortable: true},
        {text: "STOP TIME", align: "center", value: "stop_time", sortable: true},
      ],
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doRefresh(){
      this.statusProgress = true
      await service.getAll()
        .then(res => {
          this.logs = res.data.data
          let number = 1
          for (let log of this.logs) {
            log.number = number++
            let {logConfigDetails} = log
            if (logConfigDetails.length > 0) {
              logConfigDetails.sort(service.sortOrder('create_at'))
            }
          }
        })
        .catch(err => {
          console.log(err)
          console.log(err.response)
        })
      this.statusProgress = false
    },
  },
  mounted() {
    this.doRefresh()
  }
}
</script>